/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.BreastGYNMammoSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_MenopausalPhase;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_MenopausalPhase;


/**
 * This class represents MenopausalPhase - CID6086
 */
public class MenopausalPhase_CID6086
{

	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;
	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new MenopausalPhase_CID6086 Template 
	 */
	public MenopausalPhase_CID6086()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumMenopausalPhase Object of EnumCM_MenopausalPhase represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_MenopausalPhase enumMenopausalPhase)
	{
		switch(enumMenopausalPhase)
		{
		case BEFORE_MENOPAUSE: this.strCodeValue =EnumCV_MenopausalPhase.BEFORE_MENOPAUSE_R_41FFF.getValue(); break;
		case DURING_MENOPAUSE: this.strCodeValue =EnumCV_MenopausalPhase.DURING_MENOPAUSE_R_422A5.getValue(); break;
		case AFTER_MENOPAUSE: this.strCodeValue =EnumCV_MenopausalPhase.AFTER_MENOPAUSE_R_410C3.getValue(); break;
		case POSTSURGICAL_MENOPAUSE: this.strCodeValue =EnumCV_MenopausalPhase.POSTSURGICAL_MENOPAUSE_D7_76202.getValue(); break;
		case ARTIFICIAL_MENOPAUSE_STATE: this.strCodeValue =EnumCV_MenopausalPhase.ARTIFICIAL_MENOPAUSE_STATE_D7_76200.getValue(); break;
		}
	}
	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumMenopausalPhase Object of EnumCM_MenopausalPhase represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_MenopausalPhase enumMenopausalPhase)
	{
		switch(enumMenopausalPhase)
		{
		case BEFORE_MENOPAUSE : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.BEFORE_MENOPAUSE.getSNOMEDCTID(); break;
		case DURING_MENOPAUSE : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.DURING_MENOPAUSE.getSNOMEDCTID(); break;
		case AFTER_MENOPAUSE : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.AFTER_MENOPAUSE.getSNOMEDCTID(); break;
		case POSTSURGICAL_MENOPAUSE : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.POSTSURGICAL_MENOPAUSE.getSNOMEDCTID(); break;
		case ARTIFICIAL_MENOPAUSE_STATE : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.ARTIFICIAL_MENOPAUSE_STATE.getSNOMEDCTID(); break;
		}
	}
	/**
	 * Sets the value for MenopausalPhase
	 * @param enumMenopausalPhase Object of EnumCM_MenopausalPhase.
	 */
	public void setMenopausalPhase(EnumCM_MenopausalPhase enumMenopausalPhase)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumMenopausalPhase.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumMenopausalPhase);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumMenopausalPhase);
	}
}
